#pragma once

// The numeric version format is AAABBBCCCDDDE where:
//
// AAA - major version number
// BBB - minor version number
// CCC - bugfix version number
// DDD - alpha / beta (DDD + 500) version number
// E   - final (0) / snapshot (1)
//
// When DDDE is not 0, 1 is subtracted from AAABBBCCC. For example:
//
// Version      AAABBBCCCDDDE
//
// 0.1.0        0000010000000
// 0.1.2        0000010010000
// 1.2.3        0010020030000
// 2.2.0-a.1    0020019990010
// 3.0.0-b.2    0029999995020
// 2.2.0-a.1.z  0020019990011
//
#define LIBHELLO_VERSION       10000000ULL
#define LIBHELLO_VERSION_STR   "0.1.0"
#define LIBHELLO_VERSION_ID    "0.1.0"

#define LIBHELLO_VERSION_MAJOR 0
#define LIBHELLO_VERSION_MINOR 1
#define LIBHELLO_VERSION_PATCH 0

#define LIBHELLO_PRE_RELEASE   false

#define LIBHELLO_SNAPSHOT_SN   0ULL
#define LIBHELLO_SNAPSHOT_ID   ""
